summaryrefslogtreecommitdiff
path: root/nss/coreconf/fuzz.sh
diff options
context:
space:
mode:
Diffstat (limited to 'nss/coreconf/fuzz.sh')
-rw-r--r--nss/coreconf/fuzz.sh41
1 files changed, 41 insertions, 0 deletions
diff --git a/nss/coreconf/fuzz.sh b/nss/coreconf/fuzz.sh
new file mode 100644
index 0000000..67cb7f5
--- /dev/null
+++ b/nss/coreconf/fuzz.sh
@@ -0,0 +1,41 @@
+#!/usr/bin/env bash
+# This file is used by build.sh to setup fuzzing.
+
+set +e
+
+# Default to clang if CC is not set.
+if [ -z "$CC" ]; then
+ command -v clang &> /dev/null 2>&1
+ if [ $? != 0 ]; then
+ echo "Fuzzing requires clang!"
+ exit 1
+ fi
+ export CC=clang
+ export CCC=clang++
+ export CXX=clang++
+fi
+
+gyp_params+=(-Dtest_build=1 -Dfuzz=1 -Dsign_libs=0)
+
+# Add debug symbols even for opt builds.
+nspr_params+=(--enable-debug-symbols)
+
+if [ "$fuzz_oss" = 1 ]; then
+ gyp_params+=(-Dno_zdefs=1 -Dfuzz_oss=1)
+else
+ enable_sanitizer asan
+ # Ubsan doesn't build on 32-bit at the moment. Disable it.
+ if [ "$build_64" = 1 ]; then
+ enable_ubsan
+ fi
+ enable_sancov
+fi
+
+if [ "$fuzz_tls" = 1 ]; then
+ gyp_params+=(-Dfuzz_tls=1)
+fi
+
+if [ ! -f "/usr/lib/libFuzzingEngine.a" ]; then
+ echo "Cloning libFuzzer files ..."
+ run_verbose "$cwd"/fuzz/config/clone_libfuzzer.sh
+fi